#!/usr/bin/env bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
source /scripts/basic_vars
set -o nounset
set -o pipefail
set -o errexit
#
exec 1> >(systemd-cat -p info -t app_list) 2>&1
# set -o xtrace
if [ "2" != "$#" ]; then
  echo "Bad call $#!" | systemd-cat -p info -t app_list
  exit 0
fi
AUUID=${2}
OUTFILE="/tmp/application_list_${AUUID}.json"
if [ "all" = "${1}" ]; then
  echo -n "{\"list\":[" > ${OUTFILE}
  if [ -d /root/apps ]; then
    for ma in $(ls /root/apps || true); do
      ms=$(systemctl is-active ${ma}.service || true)
      PRINTAPPNAME=$(jq .name /root/apps/${ma}/config/application.json | tr -d '"')
      VERSION=$(jq .version /root/apps/${ma}/config/application.json | tr -d '"')
      if [ "active" = "${ms}" ]; then
        echo -n "{\"app\":\"${PRINTAPPNAME}\",\"is-active\":\"true\",\"version\":\"${VERSION}\"}" >> ${OUTFILE}
      else
        echo -n "{\"app\":\"${PRINTAPPNAME}\",\"is-active\":\"false\",\"version\":\"${VERSION}\"}" >> ${OUTFILE}
      fi
      if [ $(ls /root/apps | wc -l || true) -gt 1 ]; then
        echo -n "," >> ${OUTFILE}
      fi
    done
  fi
  echo -n "]}" >> ${OUTFILE}
  sed -i "s#},]#}]#g" ${OUTFILE}
elif [ "1" = "$#" ]; then
  APPNAME=${1}
  if [ -d /root/apps/${APPNAME} ]; then
    ms=$(systemctl is-active ${APPNAME}.service || true)
    PRINTAPPNAME=$(jq .name /root/apps/${APPNAME}/config/application.json | tr -d '"')
    VERSION=$(jq .version /root/apps/${APPNAME}/config/application.json | tr -d '"')
    if [ "active" = "${ms}" ]; then
      echo "{\"list\":[{\"app\":\"${PRINTAPPNAME}\",\"is-active\":\"true\",\"version\":\"${VERSION}\"}]}" > ${OUTFILE}
    else
      echo "{\"list\":[{\"app\":\"${PRINTAPPNAME}\",\"is-active\":\"false\",\"version\":\"${VERSION}\"}]}" > ${OUTFILE}
    fi
  fi
fi
#
if [ -f /tmp/application_list_debug ]; then
  cat ${OUTFILE} | systemd-cat -p info -t app_list
fi
exit 0
