#!/usr/bin/env bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
source /scripts/basic_vars
set -o nounset
set -o pipefail
set -o errexit
#
if [ "1" != "$#" ]; then exit 0; fi
#
exec 1> >(systemd-cat -p info -t app_stop) 2>&1
set -o xtrace
#
if [ -z "${is_native_applications_enabled_in_config}" ]; then
  echo "Native applications are disabled in configuration!"
  exit 3
fi
#
APPNAME=${1}
APPDIR=/root/apps/${APPNAME}
APPJSON=/root/apps/${APPNAME}/config/application.json
ONDEMAND="false"
#
sudo systemctl stop --no-block ${APPNAME}.service || true
#
if [ -f ${APPJSON} ]; then
  ONDEMAND=$(/usr/bin/jq '.ondemand' ${APPJSON} | tr -d '"' )
  if [ "true" = ${ONDEMAND} ]; then
    sudo systemctl disable ${APPNAME}.service 2>/dev/null
  fi
fi
sudo systemctl reset-failed ${APPNAME}.service || true
exit 0
